unit IntLists;

interface
uses sysutils,classes,aconsts,typinfo,windows;
{$R ASTRINGS.RES}
{----------------------------------------------}
const
      conotifyevent='TNotifyEvent';
      cocloseevent='TCloseEvent';
      coprocResult='.Result';
      binheader='KS1.0';
type
     TDynaVarNameTOId=function(const S:String):Integer of object;
     TDynaSetVar=procedure(ID:Integer;Value:Variant) of object;
     TDynaGetVar=function(ID:Integer):Variant of object;
type
  ECompilerError = class(Exception);
{-------------------}
type  TToken=record
      ID:Integer;
      Data:Variant;
      end;

type CharSet=set of char;

const
WhiteSpaces:CharSet=['+','-','/','*','(',')',':','=',',',';','>','<',
            '$','.','#','[',']','^','@','&','~','|','%'];
BlackSpaces:CharSet=[#1..#32];
StopChars:CharSet=[#0..#32,'+','-','/','*','(',')',':','=',',','''',
          '{','}',';','>','<','$','.','#','[',']','"','^','@','&','~','|','%'];
FirstIdentChar:CharSet=['A'..'Z',''..'','_'];
IdentBackChars:CharSet=['A'..'Z','_','0'..'9',''..''];
Digit:CharSet=['0'..'9'];
HexDigit:CharSet=['0'..'9','A'..'F'];
{----------------------------------------------}
{ Writer types }
const wInteger=1;
      wDouble =2;
      wString =3;
      WBoolean=4;
{----------------------------------------------}
const
{ OutPut Codes}
      ocAdd           =0;
      ocSub           =1;
      ocMul           =2;
      ocDiv           =3;
      ocMod           =4;
      ocSlash         =5;
      ocShl           =6;
      ocShr           =7;
      ocNot           =8;
      ocOr            =9;
      ocXor           =10;
      ocAnd           =11;
      ocGreaterEqual  =12;
      ocEqual         =13;
      ocLessEqual     =14;
      ocNotEqual      =15;
      ocGreater       =16;
      ocLess          =17;
      ocNeg           =18;
      ocGoto          =19;
      ocIF            =20;
      ocloadconst     =23;
      ochalt          =26;
      ocincvar        =29;
      ocdecvar        =30;
      ocbackcode      =34;
      ocextfun        =42;
      ocextproc       =43;
      ocsetself       =44;
      ocloadextvar    =45;
      ocstoreextvar   =46;
      ocselffromvar   =47;
      ocmov           =48;
      occall          =49;
      ocreturn        =50;
      ocvarraycreate  =51;
      ocsetvarray     =52;
{ Error Constants }

      erUnexpEOFComment=1; { When EOF received in Comment State }
      erUnexpEOFString=2;  { When EOF received in String State }
      erIdentBack=3;
      erUnknownIdent=4;


{ Character IDs}
      idEndOfFile=0;
      idNewLine=$0a;
      idpower=Integer('^');
      idPoint=Integer('.');
      idDollar=Integer('$');
      idDelimeter=Integer(';');
      idgreater=Integer('>');
      idless=Integer('<');
      idComma=Integer(',');
      idPlus=Integer('+');
      idMinus=Integer('-');
      idSlash=Integer('/');
      idStar=Integer('*');
      idOpenBracket=Integer('(');
      idCloseBracket=Integer(')');
      idOpenComment=Integer('{');
      idCloseComment=Integer('}');
      idEqual=Integer('=');
      idnotequal=integer('#');
      id2Points=Integer(':');
      idStringChar=Integer('''');
      id2StringChar=Integer('"');
      idsqopenbracket=integer('[');
      idsqclosebracket=integer(']');
 { ID Bases and ID ends }
      idBase=256;
      idReservedBase=1000;
      idReservedEnd=1999;
      idTypeBase=2000;
      idTypeEnd=2999;

 { Other IDs }
      idIdentifier=idBase+0;
      idStringConst=idBase+1;
      idNumberConst=idBase+2;
      id2ndIdentifier=idBase+3;
      idError=idBase+4;
      idresconst=idbase+5;
      idhexConst=idbase+6;

 { Reserverd Words [idReservedBase,idReservedEnd] }
      id_Program=idReservedBase+0;
      id_Label  =idReservedBase+1;
      id_Goto   =idReservedBase+2;
      id_Var    =idReservedBase+3;
      id_begin  =idReservedBase+4;
      id_end    =idReservedBase+5;

      id_and    =idReservedBase+6;
      id_or     =idReservedBase+7;
      id_xor    =idReservedBase+8;
      id_not    =idReservedBase+9;
      id_shl    =idReservedBase+10;
      id_shr    =idReservedBase+11;
      id_div    =idReservedBase+12;
      id_mod    =idReservedBase+13;

      id_true   =idReservedBase+14;
      id_false  =idReservedBase+15;

      id_if     =idReservedBase+16;
      id_then   =idReservedBase+17;
      Id_else   =idReservedBase+18;

      id_while  =idReservedBase+19;
      id_repeat =idReservedBase+20;
      id_until  =idReservedBase+21;
      id_for    =idReservedBase+22;
      id_to     =idReservedBase+23;
      id_downto =idReservedBase+24;
      id_do     =idReservedBase+25;
      id_nil    =idReservedBase+27;

 { Types [idTypeBase,idTypeEnd] }

 { Integer Types }

      id_Byte     =idtypebase+0;
      id_word     =idtypebase+1;
      id_longint  =idtypebase+2;
      id_Integer  =idtypebase+3;
      id_shortint =idtypebase+4;
      id_cardinal =idtypebase+5;
      id_smallint =idtypebase+6;

 { Real Types }
      id_Real     =idtypebase+7;
      id_Single   =idtypebase+8;
      id_Double   =idtypebase+9;
      id_Extended =idtypebase+10;
      id_Comp     =idtypebase+11;
      id_Currency =idtypebase+12;

 { Boolean Types }
      id_Boolean  =idtypebase+13;
      id_ByteBool =idtypebase+14;
      id_WordBool =idtypebase+15;
      id_LongBool =idtypebase+16;

 {}
      id_string  =idtypebase+17;
      id_variant =idtypebase+18;
      id_pointer =idtypebase+19;

      IdSqlOrder=idReservedBase+27;
      idsqlasc  =idReservedBase+28;
      idsqldesc =idReservedBase+29;
      idsqlby   =idReservedBase+30;

      id_unitinit  =idReservedBase+31;
      id_unitfinal =idReservedBase+32;
      id_class     =idReservedBase+33;
      id_type      =idReservedBase+34;
      id_constr    =idReservedBase+35;
      id_destr     =idReservedBase+36;
      id_uses      =idReservedBase+37;
      id_unit      =idReservedBase+38;
      id_interface =idReservedBase+39;
      id_implement =idReservedBase+40;
      id_procedure =idReservedBase+41;
      id_private   =idReservedBase+42;
      id_public    =idReservedBase+43;
      id_protected =idReservedBase+44;
      id_published =idReservedBase+45;
      id_function  =idReservedBase+46;
      id_const     =idReservedBase+47;
      id_property  =idReservedBase+48;
      id_virtual   =idReservedBase+49;
      id_override  =idReservedBase+50;
      id_dynamic   =idReservedBase+51;
      id_record    =idReservedBase+52;
      id_forward   =idReservedBase+53;

      id_index     =idReservedBase+54;
      id_read      =idReservedBase+55;
      id_write     =idReservedBase+56;
      id_stored    =idReservedBase+57;
      id_default   =idReservedBase+58;
      id_abstract  =idReservedBase+59;
      id_go        =idReservedBase+60;
      id_sqlwhere  =idReservedBase+61;
{------------------------------}
const maxparams=100;
      cbuseunit=1;
Type
     IntListError=class(exception);
     TUnitProc=procedure;
     TCallBackFun=procedure(I:integer;P:Pointer) of object;

     TResConstListItem=class
      Value:Variant;
     end;

     TResConstList=class(TStringList)
      public
       constructor Create;
       procedure AddConst(const AName:String;var V:Variant);
       destructor Destroy;override;
     end;
 
     TUnitlistItem=class
      ProcAddr:TUnitProc;
      Processed:Boolean;
     end;

     TUnitList=class(TStringList)
      public
       constructor Create;
       destructor  Destroy;override;
       procedure   AddUnit(Const Aname:String;P:TunitProc);
       procedure   UseUnit(Const Aname:String;b:boolean);
     end;

     TDynaVarItem=class
      VarNameTOID:TDynaVarNameToID;
      SetVar:TDYnaSetVar;
      GetVar:TDynaGetVar;
      LocalVar:Boolean;
      OwnerSelf:TObject;
     end;

     TDynaVars=class(TStringlist)
     public
     function GetDynaObject(const vname:string;AOwnerSelf:TObject;
              var varid,funid:integer):boolean;
     procedure AddDyna(const name:string;
               Avarnametoid:TDynaVarNameTOID;
               ASetVar:TDYnaSetVar;
               AGetVar:TDynaGetVar;LocalVars:Boolean;AOwnerSelf:TObject);
     procedure DelDyna(const name:String);
     constructor Create;
     destructor Destroy;override;
     end;

     TObjectListItem=class
      Pearent:String;
     end;

     TObjectTypesList=class(TStringList)
     public
      constructor Create;
      procedure Add(const obj,par:string);
      Function FindPearent(const par:string):string;
      destructor Destroy;override;
     end;


     tobjitem=class
     objtype:string;
     tobj:tobject;
     end;

     tobjcollect=class(tstringlist)
     public
      constructor Create;
      destructor Destroy;override;
      Function ObjbyName(const aname:string;var tob:tobjitem):boolean;
     end;

     pvariantarray=^tvariantarray;
     tvariantarray=array[0..1000] of variant;

     tproctype=function(slf:tobject;var s:array of variant):variant;
     tbytearray=array[0..maxparams] of byte;
     TFunListItem=class
      ProcAddr:tproctype;
      ParCount:integer;
      Fun:boolean;
      Params:tbytearray;  {0-stack param  1-var param 2-no param
                           3-open array param}
      IsProp:Boolean;
      IsPropSet:Boolean;
     end;

const
   tifunction =2;
   tivariable =0;
   tiprocedure=1;
type
     TIdentListItem=class
     public
      ID:Integer;
      VType:String;
      IdentType:Integer;  {0-Variable 1-procedure 2-function}
      ParCount:Integer;
      Params:tbytearray;
      ParamNames:TStringList;
      constructor Create;
      destructor Destroy;override;
      procedure Assign(Source:TIdentlistItem);
     end;

     tbinprogitem=record
      opcode,a,b:integer;
     end;

     tprogarray=array[0..1000] of tbinprogitem;
     pprogarray=^tprogarray;
     pintarray=^tintarray;
     tintarray=array[0..1000] of integer;

     TFunList=class(TStringList)
     public
     constructor Create;
     procedure   AddItem(const Aname:string;ProcAddr:TProcType;
                 Fun,IsProp,IsPropSet:Boolean;const Params:array of byte);
     destructor  Destroy;override;
     end;

     TIdentList=class(TStringList)
     public
     constructor Create;
     function    AddItem(const Aname:string;ID:Integer):Integer;
     function    IDByName(const AName:string;var AID:integer):boolean;
     function    ItemByName(const Aname:string;var Ident:TIdentListItem):boolean;
     destructor  Destroy;override;
     procedure   Assign(Source:TPersistent);override;
     end;

     TConstItem=class(TCollectionItem)
     public
     Data:Variant;
     end;

     TConstList=class(TCollection)
     public
     function newitem(adata:variant):integer;
     end;

     TIDLabelItem=class(TCollectionItem)
     public
     referenced:boolean;
     exist:boolean;
     public
     Place:integer;
     end;

     TIDLabelList=class(TCollection)
     public
     function newitem:integer;
     procedure SetPlace(index,aplace:integer);
     procedure SetReference(index:integer);
     function existlabels:boolean;
     end;

     TProgItem=class(TCollectionItem)
     public
     OpCode:integer;
     A:integer;
     B:integer;
     end;

     TProgCollect=class(TCollection)
     public
     procedure putop(ID,AA,AB:integer);
     end;
{------------------------------}
var FunList,Funs:TFunList;
    ResWords:TIdentList;
    DynaVars:TDynaVars;
    ResConsts:TResConstList;
{------------------------------}
procedure myerrorout(const s:string);
procedure mystdout(const s:string);
function CallHalProc(const procName:String;slf:tobject;
         var s:array of variant):variant;
function GetHalProcAddr(const FunName:String):tproctype;
procedure DeclareUnit(const UnitName:String;AProcAddr:TUnitProc);
function  ObjToVar(S:TObject):Variant;
function  VarToObj(S:Variant):TObject;
function  OV(S:TObject):Variant;
function  VO(S:Variant):TObject;
procedure AddObjectType(const objname,parname:string);
function  RegisteredClassName(const cname:string):boolean;
function  GetPearent(const objname:string):string;
procedure AddProc(const Aname:string;ProcAddr:TProcType;const Params:array of byte);
procedure AddFun(const Aname:string;ProcAddr:TProcType;const Params:array of byte);
procedure AddProp(const Aname:string;ProcAddr,SetProcAddr:TProcType);
procedure AddArrayProp(const Aname:string;ADim:Integer;ProcAddr,SetProcAddr:TProcType);
procedure NewR(const AName:string;AID:Integer);
procedure UseUnit(const UnitName:String);
Function UnUniqName(Const Name:String):String;
procedure disposeconsts(var c:array of tvarrec;size:integer);
function min(a,b:Integer):Integer;
procedure UseUnitts(const UnitNames:Array of String);
procedure setnotifyevent(ControlLink:TObject;const eventlink:string;fmynotifyevent:TNotifyEvent);
function SetToken(ID:integer;V:Variant):TToken;
function Hex2Dec(const S: string): Longint;
procedure outbyte(s:TStream;c:byte);
procedure outstring(s:TStream;const mys:string);
procedure outboolean(s:TStream;b:boolean);
procedure outint(s:TStream;c:integer);
procedure outdouble(s:TStream;c:double);
function getbyte(S:Tstream):byte;
function getstring(S:Tstream):string;
function getboolean(S:Tstream):boolean;
function getdouble(S:Tstream):double;
function getint(S:Tstream):integer;
function upreg(a:byte):byte;
procedure UseUnits;
Procedure AddLocalVar(const name:string;
          Avarnametoid:TDynaVarNameTOID;
          ASetVar:TDYnaSetVar;
          AGetVar:TDynaGetVar;AOwnerSelf:TObject);
procedure AddDynaVar(const name:string;
          Avarnametoid:TDynaVarNameTOID;
          ASetVar:TDYnaSetVar;
          AGetVar:TDynaGetVar);
procedure deldynavar(const name:String);
Procedure VarToConsts(Var V:Variant;Var P:Array of tvarrec;Var MaxP:Integer);
procedure AddConst(const AName:String;V:Variant);
Procedure VarToStringS(Var V:Variant;Var P:Array of String;Var MaxP:Integer);

procedure ClearHalParams;
Function GetHalParam(const ParamName:String):Variant;
procedure SetHalParam(const ParamName:String;Value:Variant);
{------------------------------}
type
  TIntStack=class(TList)
  public
   Function Pop:Integer;
   Function Push(I:Integer):Integer;
  end;

Type TInternalVarItem=Class
      Value:Variant;
     end;

     TInternalVar=class(TStringList)
     public
     MyResult:Variant;
     function    DynaGetVar(ID:Integer):Variant;
     procedure   DynaSetVar(ID:Integer;Value:Variant);
     function    DynaVarNameTOId(const S:String):Integer;
     constructor Create;
     destructor Destroy;override;
     end;
{------------------------------}
const stintvar='__InternalVar';
var InternalVariables:TInternalVar;
    ObjectTypes:TObjectTypesList;
    UnitList:TUnitList;
implementation
{-------------------------------------------}
Function UnUniqName(Const Name:String):String;
var i,Code,k:integer;
begin
 i:=length(Name);
 While (I>0) and (Name[i]<>'_') do dec(i);
 If (i=0) then Result:=Name else begin
  Val(Copy(Name,i+1,MaxInt),k,Code);
  If Code<>0 then Result:=Name else Result:=Copy(Name,1,i-1);
 end;
end;
{------------------------------}
procedure disposeconsts(var c:array of tvarrec;size:integer);
 var i:integer;
begin
 for i:=0 to size do If C[i].Vtype=VTVariant then
  FreeMem(C[i].VVariant,SizeOf(Variant));
end;
{--------------------------------}
procedure ClearHalParams;
begin InternalVariables.Clear;
end;
{--------------------------------}
Function GetHalParam(const ParamName:String):Variant;
Var i:integer;
begin
 Result:=0;
 With InternalVariables do begin
  If Find(AnsiUpperCase(ParamName),i)=false then exit;
  Result:=(Objects[i] as TInternalVarItem).Value;
 end;
end;
{--------------------------------}
procedure SetHalParam(const ParamName:String;Value:Variant);
var R:TInternalVarItem;
    S:String;
    i:integer;
begin S:=AnsiUpperCase(ParamName);
 With InternalVariables do begin
  If Find(S,i) then (Objects[i] as TInternalVarItem).Value:=Value
  else begin
    R:=TInternalVarItem.Create;
    R.Value:=Value;
    AddObject(S,R);
  end;
 end;
end;
{--------------------------------}
function CallHalProc(const procName:String;
         slf:tobject;var s:array of variant):variant;
var R:TProcType;
begin
 Result:=NULL;
 R:=GetHalProcAddr(procname);
 If Assigned(R) then Result:=R(slf,s)
 else raise
 Exception.Create(FMTLoadStr(fun_notfound,[AnsiUpperCase(procname)]));
end;
{--------------------------------}
function GetHalProcAddr(const FunName:String):tproctype;
var i:integer;
begin
 Result:=nil;
 If Funs.Find(AnsiUpperCase(FunName),i) then
    Result:=TFunListItem(Funs.Objects[i]).ProcAddr;
end;
{--------------------------------}
procedure AddConst(const AName:String;V:Variant);
begin
 ResConsts.AddConst(AName,V);
end;
{--------------------------------}
constructor TResConstList.Create;
begin
 inherited;
 sorted:=true;
 duplicates:=dupignore;
end;
{--------------------------------}
procedure TResConstList.AddConst(const AName:String;var V:Variant);
var t:tresconstlistitem;
begin
 t:=tresconstlistitem.Create;
 t.Value:=V;
 AddObject(AnsiUpperCase(AName),t);
end;
{--------------------------------}
destructor TResConstList.Destroy;
var i:integer;
begin
 For i:=0 to Count-1 do Objects[i].Free;
 inherited;
end;
{--------------------------------}
procedure UseUnitts(const UnitNames:Array of String);
var i:integer;
begin
 for i:=0 to High(UnitNames) do
  UseUnit(UnitNames[i]);
end;
{--------------------------------}
procedure UseUnits;
var i:Integer;
begin
 For i:=0 to UnitList.Count-1 do UnitList.UseUnit(UnitList.Strings[i],false);
end;
{--------------------------------}
procedure UseUnit(const UnitName:String);
begin
 UnitList.UseUnit(UnitName,true);
end;
{--------------------------------}
procedure DeclareUnit(const UnitName:String;AProcAddr:TUnitProc);
begin
 UnitList.AddUnit(UnitName,AProcAddr);
end;
{--------------------------------}
constructor TUnitList.Create;
begin
 inherited;
 Sorted:=True;
 Duplicates:=dupError;
end;
{--------------------------------}
destructor TUnitList.Destroy;
var i:integer;
begin
 For i:=0 to Count-1 do Objects[i].Free;
 inherited;
end;
{------------------------------------}
{$ifdef Demo}
function DelphiRunning : boolean;
var
  H1, H2, H3, H4 : Hwnd;
const
  A1 : array[0..12] of char = 'TApplication'#0;
  A2 : array[0..15] of char = 'TAlignPalette'#0;
  A3 : array[0..18] of char = 'TPropertyInspector'#0;
  A4 : array[0..11] of char = 'TAppBuilder'#0;
  T1 : array[0..6] of char = 'Delphi'#0;
begin
  H2 := FindWindow(A2, nil);
  H3 := FindWindow(A3, nil);
  H4 := FindWindow(A4, nil);
  Result := (H2 <> 0) and
            (H3 <> 0) and (H4 <> 0);
end;
{$endif}
{--------------------------------}
procedure TUnitList.AddUnit(Const Aname:String;P:TunitProc);
var i:integer;
    s:String;
    t:TUnitListItem;
begin s:=AnsiUpperCase(AName);
 IF not Assigned(p) then
  raise Exception.CreateResFmt(bad_unit,[AName]);
 IF Find(s,i) then
  raise Exception.CreateResFmt(unit_declared,[AName]);
 t:=TunitListItem.Create;
 T.ProcAddr:=P;
 AddObject(S,T);
end;
{--------------------------------}
procedure TUnitList.UseUnit(Const Aname:String;b:boolean);
var i:integer;
    s:TUnitListItem;
begin
 If Find(AnsiUpperCase(AName),i)=false then exit;
 s:=TUnitListItem(Objects[i]);
 IF S.Processed then exit;
 S.ProcAddr;
 For i:=0 to Count-1 do
 If @TUnitListItem(Objects[i]).ProcAddr=@S.ProcAddr then
 TUnitListItem(Objects[i]).Processed:=true;
end;
{--------------------------------}
Procedure VarToStringS(Var V:Variant;Var P:Array of String;Var MaxP:Integer);
var i:integer;
begin
 MaxP:=V[0];
 for i:=1 to V[0] do P[i-1]:=V[i];
end;
{--------------------------------}
Procedure VarToConsts(Var V:Variant;Var P:Array of tvarrec;Var MaxP:Integer);
var i:integer;
    PV:PVariant;
begin
 MaxP:=V[0];
 for i:=1 to MaxP do begin
  GetMem(PV,Sizeof(Variant));
  PV^:=V[i];
  P[i-1].VVariant:=PV;
  p[i-1].Vtype:=VtVariant;
 end;
end;
{--------------------------------}
procedure TIdentList.Assign(Source:TPersistent);
var i:integer;
    P1:TIdentListItem;
begin
 inherited;
 for i:=0 to Count-1 do begin
  P1:=tidentlistitem(Objects[i]);
  Objects[i]:=TObject(TIdentListitem.Create);
  (Objects[i] as tidentlistitem).Assign(P1);
 end;
end;
{--------------------------------}
procedure TIdentListItem.Assign(Source:TIdentlistItem);
begin
ID:=Source.ID;
VType:=Source.Vtype;
IdentType:=Source.IdentType;
ParCount:=Source.ParCount;
Params:=Source.Params;
ParamNames.Assign(Source.ParamNames);
end;
{--------------------------------}
constructor TIdentListItem.Create;
begin
inherited;
ParamNames:=TStringList.Create;
end;
{--------------------------------}
destructor TIdentListItem.Destroy;
begin
ParamNames.Free;
inherited;
end;
{--------------------------------}
function OV(S:TObject):Variant;
begin Result:=ObjToVar(S);
end;
{--------------------------------}
function VO(S:Variant):TObject;
begin Result:=VarToObj(S);
end;
{--------------------------------}
function ObjToVar(S:TObject):Variant;
begin
TVarData(Result).VPointer:=Pointer(s);
TVarData(Result).VType:=vtinteger;
end;
{--------------------------------}
function VarToObj(S:Variant):TObject;
begin
Result:=TObject(TVarData(S).VPointer);
end;
{--------------------------------}
constructor TInternalVar.Create;
begin
inherited;
 AddDynaVar(stintvar,DynaVarNameToID,DynaSetVAR,dynagetvar);
end;
{--------------------------------}
destructor TInternalVar.Destroy;
var i:integer;
begin
 DelDynaVar(stintvar);
 For i:=0 to Count-1 do Objects[i].Free;
inherited;
end;
{--------------------------------}
function TInternalVar.DynaVarNameTOId(const S:String):Integer;
var i:integer;
begin
 if CompareText(s,'Result')=0 then Result:=0
 else if Find(s,i) then Result:=i+1
 else Result:=-1;
 end;
{--------------------------------}
procedure TInternalVar.DynaSetVar(ID:Integer;Value:Variant);
begin
 If ID=0 then MyResult:=Value else
  If ID-1<=Count then (Objects[ID-1] as TInternalVarItem).Value:=Value;
end;
{--------------------------------}
function TInternalVar.DynaGetVar(ID:Integer):Variant;
begin
 If ID=0 then Result:=MyResult else begin
  If ID-1<=Count then Result:=(Objects[ID-1] as TInternalVarItem).Value
  else Result:=0;
 end;
end;
{------------------------------}
Procedure AddLocalVar(const name:string;
          Avarnametoid:TDynaVarNameTOID;
          ASetVar:TDYnaSetVar;
          AGetVar:TDynaGetVar;AOwnerSelf:TObject);
begin
 DynaVars.AddDyna(name,Avarnametoid,ASetVar,AGetVar,true,AOwnerSelf);
end;
{------------------------------}
procedure AddDynaVar(const name:string;
          Avarnametoid:TDynaVarNameTOID;
          ASetVar:TDYnaSetVar;
          AGetVar:TDynaGetVar);
begin
 DynaVars.AddDyna(name,Avarnametoid,ASetVar,AGetVar,false,DynaVars);
end;
{------------------------------}
procedure deldynavar(const name:String);
begin
Dynavars.DelDyna(name);
end;
{------------------------------}
procedure TDynaVars.AddDyna(const name:string;
          Avarnametoid:TDynaVarNameTOID;
          ASetVar:TDYnaSetVar;
          AGetVar:TDynaGetVar;LocalVars:Boolean;AOwnerSelf:TObject);
var t:tdynavaritem;
begin
 t:=tdynavaritem.create;
 With t do begin
  varnametoid:=Avarnametoid;
  SetVar:=ASetVar;
  GetVar:=AGetVar;
  LocalVar:=LocalVars;
  OwnerSelf:=AOwnerSelf;
 end;
 AddObject(AnsiUpperCase(name),t);
end;
{------------------------------}
function TDynaVars.GetDynaObject(const vname:string;AOwnerSelf:TObject;
         var varid,funid:integer):boolean;
var i:integer;
begin
Result:=false;
for i:=count-1 downto 0 do
If ((Objects[i] as TDynaVarItem).LocalVar=false)
   or
   (AOwnerSelf=(Objects[i] as TDynaVarItem).OwnerSelf) then
begin
varid:=(Objects[i] as TDynaVarItem).VarNameToID(vname);
if (varid<>-1) then begin
funid:=i;
Result:=true;
exit;
end;
end;
end;
{------------------------------}
procedure TDynaVars.DelDyna(const name:String);
var i:integer;
begin
i:=IndexOF(AnsiUpperCase(name));
if i<>-1 then Delete(i);
end;
{------------------------------}
constructor TDynaVars.Create;
begin
  inherited;
end;
{------------------------------}
destructor TDynaVars.Destroy;
var i:integer;
begin
for i:=0 to Count-1 do if assigned(Objects[i]) then Objects[i].Free;
inherited;
end;
{------------------------------}
function RegisteredClassName(const cname:string):boolean;
var i:integer;
begin
UseUnit(cname);
Result:=ObjectTypes.Find(ansiUpperCase(cname),i);
end;
{------------------------------}
procedure AddObjectType(const objname,parname:string);
begin
ObjectTypes.Add(ansiuppercase(objname),ansiuppercase(parname));
end;
{------------------------------}
function GetPearent(const objname:string):string;
begin Result:=objecttypes.FindPearent(ansiuppercase(objname));
end;
{------------------------------}
procedure AddProc(const Aname:string;ProcAddr:TProcType;const Params:array of byte);
begin
 FunList.AddItem(Aname,ProcAddr,true,false,false,Params);
end;
{------------------------------}
procedure AddFun(const Aname:string;ProcAddr:TProcType;
          const Params:array of byte);
begin
 {$IFDEF DEMO}
  If not delphiRunning then exit;
 {$ENDIF}
 FunList.AddItem(Aname,ProcAddr,false,false,false,Params);
end;
{------------------------------}
procedure AddArrayProp(const Aname:string;ADim:Integer;ProcAddr,SetProcAddr:TProcType);
var A:Array[0..100] of byte;
    i:integer;
begin
 {$IFDEF DEMO}
  If not delphiRunning then exit;
 {$ENDIF}
 For i:=0 to ADim-1 do A[i]:=0;A[ADim]:=4;
 FunList.AddItem(Aname,ProcAddr,false,true,false,Slice(A,ADim));
 If Assigned(SetProcAddr) then
 FunList.AddItem(Aname+'_VET',SetProcAddr,false,true,true,Slice(A,ADim+1));
end;
{------------------------------}
procedure AddProp(const Aname:string;ProcAddr,SetProcAddr:TProcType);
begin
 {$IFDEF DEMO}
  If not delphiRunning then exit;
 {$ENDIF}
 FunList.AddItem(Aname,ProcAddr,false,true,false,[2]);
 If Assigned(SetProcAddr) then
 FunList.AddItem(Aname+'_SET',SetProcAddr,false,true,true,[0]);
end;
{------------------------------}
constructor TObjCollect.Create;
begin
 inherited;
 sorted:=true;
end;
{------------------------------}
destructor TObjCollect.Destroy;
var i:integer;
begin
 for i:=0 to Count-1 do if assigned(Objects[i]) then Objects[i].Free;
 inherited;
end;
{------------------------------}
Function TObjCollect.ObjbyName(const aname:string;var tob:tobjitem):boolean;
var i:integer;
begin
 tob:=nil;
 Result:=Find(aname,i);
 if result then tob:=Tobjitem(Objects[i]);
end;
{------------------------------}
procedure TProgCollect.putop(ID,AA,AB:integer);
var s:tprogitem;
begin
 s:=tprogitem(add);
 s.opcode:=id;
 s.a:=aa;
 s.b:=ab;
end;
{------------------------------}
function TIDLabelList.newitem:integer;
begin
 Result:=TIDLabelItem(Add).Index;
end;
{------------------------------}
function TIdLabelList.existlabels:boolean;
var i:integer;
    s:tidlabelitem;
begin
 Result:=false;
 for i:=0 to count-1 do begin
  s:=tidlabelitem(items[i]);
  if s.exist<>s.referenced then exit;
 end;
 Result:=true;
end;
{------------------------------}
procedure TIdLabelList.SetReference(index:integer);
begin
 tidlabelitem(items[index]).referenced:=true;
end;
{------------------------------}
procedure TIdLabelList.SetPlace(index,aplace:integer);
var s:tidlabelitem;
begin
 s:=tidlabelitem(items[index]);
 s.place:=aplace;
 s.exist:=true;
end;
{------------------------------}
function tconstlist.newitem(adata:variant):integer;
var t:tconstitem;
begin
 t:=tconstitem(Add);
 t.data:=adata;
 Result:=t.index;
end;
{------------------------------}
constructor TObjectTypesList.Create;
begin
 inherited Create;
 Sorted:=true;
end;
{------------------------------}
procedure TObjectTypesList.Add(const obj,par:string);
var f:TObjectListItem;
begin
 f:=TObjectListItem.Create;
 f.Pearent:=par;
 addobject(AnsiUpperCase(obj),f);
end;
{------------------------------}
Function TObjectTypesList.FindPearent(const par:string):string;
var i:integer;
begin
 if Find(par,i) then Result:=tobjectlistitem(objects[i]).pearent else
  Result:='';
end;
{------------------------------}
destructor TObjectTypesList.Destroy;
var i:integer;
begin
for i:=0 to Count-1 do if assigned(Objects[i]) then Objects[i].Free;
inherited destroy;
end;
{------------------------------}
constructor TFunList.Create;
begin
 inherited Create;
 Sorted:=true;
 Duplicates:=dupError;
end;
{------------------------------}
destructor  TFunList.Destroy;
var i:integer;
begin
for i:=0 to Count-1 do if assigned(Objects[i]) then Objects[i].Free;
inherited destroy;
end;
{------------------------------}
procedure   TFunList.AddItem(const Aname:string;ProcAddr:TProcType;
            Fun,IsProp,IsPropSet:Boolean;const Params:array of byte);
var t:TFunListItem;
    i:integer;
begin

 {$IFDEF DEMO}
  If not delphiRunning then exit;
 {$ENDIF}
try
 t:=TFunListItem.Create;
 if params[0]=2 then t.parcount:=0 else
 t.ParCount:=min(maxparams,high(Params)+1);
 t.Fun:=Fun;
 t.IsProp:=IsProp;
 t.IsPropSet:=IsPropSet;
 t.procaddr:=procaddr;
 if params[0]<>2 then
 for i:=0 to min(high(Params),maxparams) do t.Params[i]:=Params[i];
 addobject(AnsiUpperCase(aname),t)
except
 raise Exception.CreateResFmt(already_fun,[ANAme]);
end;
end;
{------------------------------}
function TIdentList.ItemByName(const Aname:string;var Ident:TIdentListItem):boolean;
var i:integer;
begin
ident:=nil;
Result:=Find(aname,i);
if result then Ident:=TIdentListItem(Objects[i]);
end;
{------------------------------}
function TIdentList.IDByName(const AName:string;var AID:integer):boolean;
var i:integer;
begin
Result:=Find(aname,i);
if result then AID:=TIdentListItem(Objects[i]).ID;
end;
{-------------------}
constructor TIdentList.Create;
begin
inherited Create;
Sorted:=true;
end;
{-------------------}
function TIdentList.AddItem(const Aname:string;ID:Integer):Integer;
var t:TIdentListItem;
begin
t:=TIdentListItem.Create;
t.Id:=id;
Result:=addobject(AnsiUpperCase(aname),t);
end;
{-------------------}
destructor TIdentList.Destroy;
var i:integer;
begin
for i:=0 to Count-1 do if assigned(Objects[i]) then Objects[i].Free;
inherited destroy;
end;
{------------------------------}
procedure myerrorout(const s:string);
var R:tproctype;
    ws:array[0..0] of variant;
begin
 R:=GetHalProcAddr('PrintError');
 ws[0]:=VarArrayCreate([0,1],varvariant);
 ws[0][0]:=1;
 ws[0][1]:=s;
 If Assigned(R) then R(nil,ws);
 ws[0]:=NULL;
end;
{------------------------------}
procedure mystdout(const s:string);
var R:tproctype;
    ws:array[0..0] of variant;
begin
 R:=GetHalProcAddr('Print');
 ws[0]:=VarArrayCreate([0,1],varvariant);
 ws[0][0]:=1;
 ws[0][1]:=s;
 If Assigned(R) then R(nil,ws);
 ws[0]:=NULL;
end;
{----------------------------------------------}
procedure NewR(const AName:string;AID:Integer);
begin ResWords.AddItem(AName,AID);end;
{----------------------------------------------}
procedure InitReservedWords;
begin
NewR('Program',id_Program);
NewR('Label',id_Label);
NewR('Goto',id_Goto);
NewR('Var',id_Var);
NewR('Begin',id_begin);
NewR('End',id_end);

NewR('Byte',id_Byte);
NewR('Word',id_word);
NewR('Longint',id_longint);
NewR('Integer',id_Integer);
NewR('ShortInt',id_shortint);
NewR('Cardinal',id_cardinal);
NewR('SmallInt',id_smallint);

NewR('Real',id_Real);
NewR('Single',id_Single);
NewR('Double',id_Double);
NewR('Extended',id_Extended);
NewR('Comp',id_Comp);
NewR('Currency',id_Currency);

NewR('Boolean',id_Boolean);
NewR('ByteBool',id_ByteBool);
NewR('WordBool',id_WordBool);
NewR('LongBool',id_LongBool);
NewR('String',id_string);
NewR('Variant',id_variant);
NewR('Pointer',id_pointer);

Newr('And',id_and);
Newr('Or',id_or);
Newr('Xor',id_xor);
Newr('Not',id_not);
Newr('Shl',id_shl);
Newr('Shr',id_shr);

Newr('Div',id_div);
Newr('Mod',id_mod);

Newr('True',id_true);
Newr('False',id_false);
Newr('Nil',id_nil);

Newr('If',id_if);
Newr('then',id_then);
Newr('else',id_else);

Newr('While',id_while);
Newr('Repeat',id_repeat);
Newr('Until',id_until);
Newr('For',id_for);
Newr('To',id_to);
Newr('DownTo',id_downto);
Newr('Do',id_do);

{------}
Newr('initialization',id_unitinit);
Newr('finalization',id_unitfinal);
Newr('class',id_class);
Newr('type',id_type);
Newr('constructor',id_constr);
Newr('destructor',id_destr);
Newr('uses',id_uses);
Newr('unit',id_unit);
Newr('interface',id_interface);
Newr('implementation',id_implement);
Newr('procedure',id_procedure);
Newr('private',id_private);
Newr('public',id_public);
Newr('protected',id_protected);
Newr('published',id_published);
Newr('function',id_function);
Newr('const',id_const);

Newr('property',id_property);
Newr('virtual',id_virtual);
Newr('override',id_override);
Newr('dynamic',id_dynamic);
Newr('record',id_record);
Newr('forward',id_forward);

Newr('index',id_index);
Newr('read',id_read);
Newr('write',id_write);
Newr('stored',id_stored);
Newr('default',id_default);
Newr('abstract',id_abstract);
{------}
end;
{------------------------}
Function myClearHalParams(slf:tobject;var s:array of variant):variant;
Begin
 ClearHalParams;
End;
{------------------------}
Function myGetHalParam(slf:tobject;var s:array of variant):variant;
Begin
 Result:=GetHalParam(S[0]);
End;
{------------------------}
Function mySetHalParam(slf:tobject;var s:array of variant):variant;
Begin
 SetHalParam(S[0],s[1]);
End;
{------------------------------}
function SetToken(ID:integer;V:Variant):TToken;
begin Result.ID:=ID;Result.Data:=V;end;
{------------------------------}
function upreg(a:byte):byte;
begin
result:=byte(upcase(char(a)));
end;
{-------------------------------}
procedure outdouble(s:TStream;c:double);
begin s.Writebuffer(c,sizeof(double));
end;
{------------------------------}
procedure outint(s:TStream;c:integer);
begin s.Writebuffer(c,sizeof(integer));
end;
{------------------------------}
procedure outbyte(s:TStream;c:byte);
begin s.Writebuffer(c,sizeof(byte));
end;
{------------------------------}
procedure outboolean(s:TStream;b:boolean);
begin s.Writebuffer(b,sizeof(boolean));
end;
{------------------------------}
function getbyte(S:Tstream):byte;
begin s.ReadBuffer(Result,sizeof(byte));end;
{------------------------------}
function getstring(S:Tstream):string;
var b:byte;
    t:string[255];
begin
b:=getbyte(s);
SetLength(t,b);
s.ReadBuffer(t[1],b);
Result:=t;
end;
{------------------------------}
function getboolean(S:Tstream):boolean;
begin s.ReadBuffer(Result,sizeof(boolean));end;
{------------------------------}
function getdouble(S:Tstream):double;
begin s.ReadBuffer(Result,sizeof(double));
end;
{------------------------------}
function getint(S:Tstream):integer;
begin s.ReadBuffer(Result,sizeof(integer));end;
{------------------------------------}
procedure setnotifyevent(ControlLink:TObject;const eventlink:string;fmynotifyevent:TNotifyEvent);
var oldpropinfo:PPropInfo;
    tm:tmethod;
    tn:tnotifyevent;
begin
if (ControlLink=nil) or (EventLink='') then exit;
oldpropinfo:=GetPropInfo(ControlLink.Classinfo,EventLink);
if CompareText(oldpropinfo^.proptype^.name,coNotifyEvent)=0 then begin
tn:=fMyNotifyEvent;
SetMethodProp(ControlLink,oldpropinfo,tmethod(tn));
end;
end;
{------------------------------------}
function Hex2Dec(const S: string): Longint;
var
  HexStr: string;
begin
  if Pos('$', S) = 0 then HexStr := '$' + S
  else HexStr := S;
  Result := StrToIntDef(HexStr, 0);
end;
{------------------------------------}
function min(a,b:Integer):Integer;
begin if a<b then Result:=a else result:=b;
end;
{------------------------------------------}
Function TIntStack.Pop:Integer;
begin
 Result:=0;
 If Count=0 then exit;
 Result:=Integer(Items[Count-1]);
 Delete(Count-1);
end;
{------------------------------------------}
Function TIntStack.Push(I:Integer):Integer;
begin
 Result:=Add(Pointer(i));
end;
{------------------------------}
procedure outstring(s:TStream;const mys:string);
var b:byte;
begin
b:=length(mys);
outbyte(s,b);
s.WriteBuffer(mys[1],b);
end;
{------------------------}
initialization FunList:=TFunList.Create;
               UnitList:=TUnitList.Create;
               Funs:=FunList;
               ResWords:=TIdentList.Create;
               InitReservedWords;
               ObjectTypes:=TObjectTypesList.Create;
               Dynavars:=TDynaVars.Create;
               InternalVariables:=TInternalVar.Create;
               ResConsts:=TResConstList.Create;

AddProc('ClearHalParams',myClearHalParams,[2]);
AddFun('GetHalParam',myGetHalParam,[0]);
AddProc('SetHalParam',mySetHalParam,[0,0]);


finalization FunList.Free;
             InternalVariables.Free;
             ResWords.Free;
             ObjectTypes.Free;
             DynaVars.Free;
             UnitList.Free;
             ResConsts.Free;
{-------------------}
end.
